/*===================================================================
CEditPositionNX
GfB^̈ʒuwNX
===================================================================*/

#include "EditPosition.h"

/*-------------------------------------------------------------------
CEditPosition::CEditPosition
RXgN^łB
-------------------------------------------------------------------*/
CEditPosition::CEditPosition(){
	m_nPosition = 0;
	m_nBackupPosition = 0;
	m_nBackupLine = 0;
}

/*-------------------------------------------------------------------
CEditPosition::operator =
Z
-------------------------------------------------------------------*/
bool CEditPosition::operator = (CEditPosition &cPos){
	m_nPosition = cPos.m_nPosition;
	m_nBackupPosition = cPos.m_nBackupPosition;
	m_nBackupLine = cPos.m_nBackupLine;
	m_iterBackupLine = cPos.m_iterBackupLine;
	return *(CPositionBase*)this = cPos;
}

/*-------------------------------------------------------------------
CEditPosition::operator ==
EӂƓǂ𔻒肷
-------------------------------------------------------------------*/
bool CEditPosition::operator == (CEditPosition &cPos){
	return m_nPosition == cPos.m_nPosition &&
		GetLineNum() == cPos.GetLineNum();
}

/*-------------------------------------------------------------------
CEditPosition::operator !=
EӂƓȂǂ𔻒肷
-------------------------------------------------------------------*/
bool CEditPosition::operator != (CEditPosition &cPos){
	return m_nPosition != cPos.m_nPosition ||
		GetLineNum() != cPos.GetLineNum();
}

/*-------------------------------------------------------------------
CEditPosition::operator <
s
-------------------------------------------------------------------*/
bool CEditPosition::operator < (CEditPosition &cPos){
	if (GetLineNum() == cPos.GetLineNum())
		return m_nPosition < cPos.m_nPosition;
	else
		return GetLineNum() < cPos.GetLineNum();
}

/*-------------------------------------------------------------------
CEditPosition::operator >
s
-------------------------------------------------------------------*/
bool CEditPosition::operator > (CEditPosition &cPos){
	if (GetLineNum() == cPos.GetLineNum())
		return m_nPosition > cPos.m_nPosition;
	else
		return GetLineNum() > cPos.GetLineNum();
}

/*-------------------------------------------------------------------
CEditPosition::MoveColumnForward
nPosړBtruełBf[^̓obNAbv܂B
-------------------------------------------------------------------*/
bool CEditPosition::MoveColumnForward(LsLines *pLine,size_t nPos){
	if (!pLine)return false;
	m_nPosition += nPos;
	/*̍sɍs`FbN*/
	if (m_nPosition > GetLinePointer()->GetLineLength()){
		if (GetLineNum() + 1 < pLine->size()){/*̍s*/
			MoveRealNext(pLine,1);
			m_nPosition = 0;
		}
		else{							/*̍s݂Ȃ*/
			m_nPosition = GetLinePointer()->GetLineLength();
		}
	}
	BackupAll();
	return true;
}

/*-------------------------------------------------------------------
CEditPosition::MoveColumnBackward
nPosɂBtruełBf[^̓obNAbv܂B
-------------------------------------------------------------------*/
bool CEditPosition::MoveColumnBackward(LsLines *pLines,size_t nPos){
	if (!pLines)return false;
	/*O̍sɍs`FbN*/
	if (m_nPosition < nPos){
		if (GetLineNum() != 0){			/*O̍s*/
			CPositionBase::MoveRealBack(1);
			m_nPosition = GetLinePointer()->GetLineLength();
		}
		else{							/*O̍s݂Ȃ*/
			m_nPosition = 0;
		}
	}
	else m_nPosition -= nPos;
	BackupAll();
	return true;
}

/*-------------------------------------------------------------------
CEditPosition::SetPosition
Z(nLinesnPosڂɈړA0x[X)łB
f[^̓obNAbv܂B
-------------------------------------------------------------------*/
bool CEditPosition::SetPosition(LsLines *pLines,size_t nLine,size_t nPos){
	if (!SetParam(pLines,nLine))					/*sZbg*/
		return false;
	if (GetLinePointer()->GetLineLength() < nPos)	/*słȂ`FbN*/
		return false;
	m_nPosition = nPos;								/*Zbg*/
	BackupAll();									/*f[^SăobNAbv*/
	return true;
}

/*-------------------------------------------------------------------
CEditPosition::SetPosition
f[^obNAbv
-------------------------------------------------------------------*/
bool CEditPosition::SetPosition(LinePt pLine,size_t nPos){
	SetParam(pLine);
	if (GetLinePointer()->GetLineLength() < nPos)	/*słȂ`FbN*/
		return false;
	m_nPosition = nPos;								/*Zbg*/
	BackupAll();
	return true;
}


/*-------------------------------------------------------------------
CEditPosition::MoveRealNext
(ϗsł͂Ȃ)sɐi߂܂Bf[^̓obNAbv܂B
-------------------------------------------------------------------*/
bool CEditPosition::MoveRealNext(LsLines *pLine,size_t nLine){
	if (!pLine)return false;
	/*ւ߂*/
	if (!CPositionBase::MoveRealNext(pLine,nLine)){
		m_nPosition = GetLinePointer()->GetLineLength();
		BackupAll();
		return false;
	}
	else{
		m_nPosition = 0;
		BackupAll();
		return true;
	}
}

/*-------------------------------------------------------------------
CEditPosition::MoveLineForwardEthic
obNAbvsAɈ_sֈړ܂B
f[^̓obNAbv܂B
-------------------------------------------------------------------*/
bool CEditPosition::MoveLineForwardEthic(LsLines *pLine,size_t nPos,
										 size_t nColumn,size_t nTabLen,int nMode){
	if (!pLine)return false;
	/*錾*/
	CFootyLine::EthicInfo cBackupInfo =
		m_iterBackupLine->CalcEthicLine(m_nBackupPosition,nColumn,nTabLen,nMode);
	CFootyLine::EthicInfo cNowInfo =
		GetLinePointer()->CalcEthicLine(m_nPosition,nColumn,nTabLen,nMode);
	/*ԉ̘_sH*/
	if (GetLinePointer()->GetEthicLine() == cNowInfo.m_nEthicLine + 1){
		/*̍s֍sA̍s邩H*/
		if (GetLineNum() + 1 != pLine->size()){
			CPositionBase::MoveRealNext(pLine,1);		/*̍s*/
			m_nPosition = GetLinePointer()->CalcRealPosition(0,cBackupInfo.m_nEthicColumn,nColumn,nTabLen,nMode);
		}
		else	/*Ȃ΂̍s̍Ō̌*/
			m_nPosition = GetLinePointer()->GetLineLength();
	}
	else{
		/*̍s̘̎_s*/
		m_nPosition = GetLinePointer()->CalcRealPosition
			(cNowInfo.m_nEthicLine + 1,cBackupInfo.m_nEthicColumn,nColumn,nTabLen,nMode);
	}
	return true;
}

/*-------------------------------------------------------------------
CEditPosition::MoveLineBackwardEthic
obNAbvsAɈ_sֈړ܂B
f[^̓obNAbv܂B
-------------------------------------------------------------------*/
bool CEditPosition::MoveLineBackwardEthic(LsLines *pLines,size_t nPos,
										  size_t nColumn,size_t nTabLen,int nMode){
	if (!pLines)return false;
	/*錾*/
	CFootyLine::EthicInfo cBackupInfo =
		m_iterBackupLine->CalcEthicLine(m_nBackupPosition,nColumn,nTabLen,nMode);
	CFootyLine::EthicInfo cNowInfo =
		GetLinePointer()->CalcEthicLine(m_nPosition,nColumn,nTabLen,nMode);
	/*ԉ̘_sH*/
	if (cNowInfo.m_nEthicLine == 0){
		/*O̍s֍sAO̍s邩H*/
		if (GetLineNum() != 0){
			CPositionBase::MoveRealBack(1);	/*O̍s*/
			m_nPosition = GetLinePointer()->CalcRealPosition(GetLinePointer()->
				GetEthicLine()-1,cBackupInfo.m_nEthicColumn,nColumn,nTabLen,nMode);
		}
		else				/*Ȃ΍ŏ̌*/
			m_nPosition = 0;
	}
	else{
		/*̍s̘̎_s*/
		m_nPosition = GetLinePointer()->CalcRealPosition
			(cNowInfo.m_nEthicLine - 1,cBackupInfo.m_nEthicColumn,nColumn,nTabLen,nMode);
	}
	return true;
}

/*-------------------------------------------------------------------
CEditPosition::BackupAll
㉺L[Ƃɉn߂ʒǔ𒆐SɃLbgړ
N悤ɂ邽߂ɑSẴf[^oϐɃobNAbv܂B
-------------------------------------------------------------------*/
void CEditPosition::BackupAll(){
	m_nBackupPosition = m_nPosition;
	m_nBackupLine = GetLineNum();
	m_iterBackupLine = GetLinePointer();
}
